//+------------------------------------------------------------------+
//|                                                  Collector08.mq4 |
//|                                                           Alenka |
//|                                               gravity001@mail.ru |
//+------------------------------------------------------------------+

#property copyright "Alenka"
#property link      "gravity001@mail.ru"

//----

#import "libping.dll"
    int ping(string dot_address,
        int packet_size_byte,
        int receive_timeout_ms,
        int reply_bytes_received[1],
        int reply_round_trip_time_ms[1],
        int reply_ttl[1]);
#import

//----

#define delimiter ';'

//----

extern int      try_cnt       = 5;
extern int      ping_slot_ms  = 10000;   // mS
extern string   ping_address  = "64.151.112.148"; //metaquotes.net
extern int      packet_size   = 32;      // Byte
extern int      timeout       = 1000;    // mS
extern int      rtt_dw        = 200;     // mS
extern int      rtt_up        = 300;     // mS
extern int      pause_dw      = 50;      // mS
extern int      pause_up      = 180000;  // mS

//----

int      init_num      = -1;
int      deinit_num    = -1;
int      start_num     = -1;
int      tick_cnt      = -1;

string   symbol        = "";
datetime tim_cur       = -1;
double   bid           = -1.0;
double   bid_pre       = -1.0;
int      digits        = -1;
int      pause_start   = -1;
int      gtc           = -1;
int      ping_slot_str = -1;

string   filename      = "";
string   log_filename  = "";
string   log_a1[];
int      log_num       = -1;
int      log_num_pre   = -1;

bool     init_chk      = -1;
int      deinit_reason = -1;

int      reply_br      = -1;
int      reply_rtt     = -1;
int      reply_ttl     = -1;
int      ping_min      = -1;
int      ping_max      = -1;
int      pause_min     = -1;
int      pause_max     = -1;

//----

void init()
{
    pause_start = GetTickCount();

    string func_name = "init()";
    chk_error(func_name, "Error Unknown", false);

    log_num = 0;
    log_num_pre = 0;

    symbol = Symbol();
    tim_cur = TimeCurrent();
    bid = MarketInfo(symbol, MODE_BID);
    chk_error(func_name, "MarketInfo(symbol, MODE_BID)", false);
    digits = MarketInfo(symbol, MODE_DIGITS);
    chk_error(func_name, "MarketInfo(symbol, MODE_DIGITS)", false);
    gtc = pause_start;
    bid_pre = bid;

    if (deinit_reason == 3 && init_num != 0)
    {
        set_log(tim_cur, caution(func_name, "deinit_reason == 3"),
            false);
        return;
    }

    init_num = 0;
    deinit_num = 0;
    start_num = 0;
    tick_cnt = 0;

    string ds = TimeToStr(tim_cur, TIME_DATE);
    string s = TimeToStr(tim_cur, TIME_SECONDS);
    string ss1 = StringSubstr(s, 0, 2);
    chk_error(func_name, "StringSubstr()", false);
    string ss2 = StringSubstr(s, 3, 2);
    chk_error(func_name, "StringSubstr()", false);
    string ss3 = StringSubstr(s, 6, 2);
    chk_error(func_name, "StringSubstr()", false);
    string ts = ss1 + "." + ss2 + "." + ss3;
    
    s = "Collector_" + symbol + "_" + ds + "_" + ts;
    filename = s + ".txt";
    log_filename = "!LOG_" + s + ".txt";
    int i = 1;
    bool chk1 = true;
    bool chk2 = true;
    int e1 = file_exist(filename, chk1);
    int e2 = file_exist(log_filename, chk2);
    while ((chk1 != false || chk2 != false) && i <= try_cnt)
    {
        i++;
        string s2 = s + "_" + i;
        filename = s2 + ".txt";
        log_filename = "!LOG_" + s2 + ".txt";
        e1 = file_exist(filename, chk1);
        e2 = file_exist(log_filename, chk2);
    }
    
    int con_chk = IsConnected();
    if (con_chk != false)
        string str_connect = "YES";
    else
        str_connect = "NO";
    
    ArrayResize(log_a1, 0);
    int e3 = chk_error(func_name, "ArrayResize()", false);
    
    reply_br = -1;
    reply_rtt = -1;
    reply_ttl = -1;
    string event = "BEGIN";
    int e4 = get_ping();
    int pause_ms = -1;
    if (ping_max == -1)
        ping_max = reply_rtt;
    if (ping_min == -1)
        ping_min = reply_rtt;
    s = crt_str(tim_cur, event, str_connect, pause_ms);
    ping_max = reply_rtt;
    ping_min = reply_rtt;
    pause_min = -1;
    pause_max = -1;
    if (
        e1 == 0
        && e2 == 0
        && e3 == 0
        && e4 == 0
        && file_write(s) == 0
        && con_chk != false
       )
    {
        init_chk = true;
        init_num++;
        complete(func_name, "ping == " + reply_rtt);
    }
    else
    {
        init_chk = false;
        set_log(tim_cur, error(-1, func_name, "init_chk == false"),
            false);
    }
}

//----

void deinit()
{
    gtc = GetTickCount();

    string func_name = "deinit()";
    chk_error(func_name, "Error Unknown", true);

    tim_cur = TimeCurrent();

    deinit_reason = UninitializeReason();
    if (deinit_reason == 3 && init_num != 0)
    {
        set_log(tim_cur, caution(func_name, "deinit_reason == 3"),
            true);
        deinit_num++;
        return;
    }

    if (IsConnected() != false)
        string str_connect = "YES";
    else
        str_connect = "NO";
    int pause_ms = gtc - pause_start;
    string event = "END";
    get_ping();
    v_pause_max(pause_ms);
    file_write(crt_str(tim_cur, event, str_connect, pause_ms));
    if (log_num_pre != log_num)
    {
        int i = 0;
        int e1 = log_file_write();
        while (e1 != 0 && i < try_cnt)
        {
            error(-1, func_name, "log_file_write() == " + e1);
            e1 = log_file_write();
            i++;
        }
    }
    string s = complete(func_name, "deinit_reason == "
        + deinit_reason + ", ping == " + reply_rtt);
    set_log(tim_cur, s, true);
    deinit_num++;
}

//----

void start()
{
    gtc = GetTickCount();

    string func_name = "start()";
    chk_error(func_name, "Error Unknown", false);

    tim_cur = TimeCurrent();
    bid = MarketInfo(symbol, MODE_BID);
    chk_error(func_name, "MarketInfo(symbol, MODE_BID)", false);
    digits = MarketInfo(symbol, MODE_DIGITS);
    chk_error(func_name, "MarketInfo(symbol, MODE_DIGITS)", false);

    if (init_chk != true)
    {
        init();
        return;
    }
    if (start_num == 0)
        first_tick();
    else
        one_tick();
    if (log_num_pre != log_num)
        log_file_write();
    start_num++;
//    complete(func_name, "no errors");
}

//----

int chk_error(string func_name, string note, bool write_to_file)
{
    int lst_err = GetLastError();
    if (lst_err != 0)
        set_log(tim_cur, error(lst_err, func_name, note),
            write_to_file);
    return(lst_err);
}

//----

string error(int err_num, string func_name, string note)
{
    string s = "ERROR #" + err_num + ". " + func_name + ", " + note
        + ".";
    Print(s);
    return(s);
}

//----

string complete(string func_name, string note)
{
    string s = "COMPLETE. " + func_name + ", " + note + ".";
    Print(s);
    return(s);
}

//----

string caution(string func_name, string note)
{
    string s = "CAUTION. " + func_name + ", " + note + ".";
    Print(s);
    return(s);
}

//----

string crt_str(datetime evn_datetime,
    string event,
    string str_connect,
    int pause_ms)
{
    string r = "********** "
        + TimeToStr(evn_datetime, TIME_DATE | TIME_SECONDS)
        + " (" + evn_datetime + "). "
        + event + ". "
        + "ADDRESS = " + ping_address + ". "
        + "CONNECTION: " + str_connect + ". "
        + "PING = " + reply_rtt + " ms, "
        + "PING_MIN = " + ping_min + " ms, "
        + "PING_MAX = " + ping_max + " ms. "
        + "PAUSE = " + pause_ms + " ms, "
        + "PAUSE_MIN = " + pause_min + " ms, "
        + "PAUSE_MAX = " + pause_max + " ms. "
        + "**********";
    return(r);
}

//----

int get_ping()
{
    string func_name = "get_ping()";
    int L_reply_br[1] = {-1};
    int L_reply_rtt[1] = {-1};
    int L_reply_ttl[1] = {-1};
    int r = ping(ping_address,
        packet_size,
        timeout,
        L_reply_br,
        L_reply_rtt,
        L_reply_ttl);
    ping_slot_str = GetTickCount();
    reply_br = L_reply_br[0];
    reply_ttl = L_reply_ttl[0];
    reply_rtt = L_reply_rtt[0];
    if (r != 0)
    {
        set_log(tim_cur, error(-1, func_name, "ping() == " + r),
            true);
        return(r);
    }
    if (reply_br != packet_size)
    {
        string s = error(-1, func_name, "reply_br == " + reply_br
            + " != packet_size == " + packet_size);
        set_log(tim_cur, s, true);
        r = 1;
    }
    if (reply_ttl > 0 && reply_ttl != L_reply_ttl[0])
    {
        s = error(-1, func_name, "reply_ttl == " + reply_ttl
            + " != L_reply_ttl[0] == " + L_reply_ttl[0]);
        set_log(tim_cur, s, true);
        r = 1;
    }
    if (r != 0)
        return(r);

    if (ping_min > reply_rtt)
        ping_min = reply_rtt;
    if (ping_max < reply_rtt)
        ping_max = reply_rtt;
    if (reply_rtt < rtt_dw)
    {
        s = error(-1, func_name, "reply_rtt == " + reply_rtt
            + " < rtt_dw == " + rtt_dw);
        set_log(tim_cur, s, true);
    }
    if (reply_rtt > rtt_up)
    {
        s = error(-1, func_name, "reply_rtt == " + reply_rtt
            + " > rtt_up == " + rtt_up);
        set_log(tim_cur, s, true);
    }
    return(r);
}

//----

void first_tick()
{
    string func_name = "first_tick()";
    int pause_ms = gtc - pause_start;
    pause_start = gtc;
    bid_pre = bid;
    tick_cnt++;
    if (GetTickCount() - ping_slot_str >= ping_slot_ms)
        get_ping();
    v_pause_max(pause_ms);
    complete(func_name, "pause == " + pause_ms + " ms, ping == "
        + reply_rtt);
    string s = tim_cur + CharToStr(delimiter)
        + DoubleToStr(bid, digits);
    file_write(s);
}

//----

void one_tick()
{
    string func_name = "one_tick()";
    int pause_ms = gtc - pause_start;
    pause_start = gtc;
    bid_pre = bid;
    tick_cnt++;
    if (GetTickCount() - ping_slot_str >= ping_slot_ms)
        get_ping();
    if (tick_cnt == 2)
        pause_min = pause_ms;
    else
    {
        if (pause_min > pause_ms)
            pause_min = pause_ms;
    }
    if (pause_ms < pause_dw)
    {
        string s = error(-1, func_name, "pause_ms == " + pause_ms
            + " < pause_dw == " + pause_dw);
        set_log(tim_cur, s, true);
    }
    v_pause_max(pause_ms);
    s = tim_cur + CharToStr(delimiter) + DoubleToStr(bid, digits);
    file_write(s);
}

//----

void v_pause_max(int a_pause_ms)
{
    string func_name = "v_pause_max()";
    if (pause_max < a_pause_ms)
        pause_max = a_pause_ms;
    if (a_pause_ms > pause_up)
    {
        string s = error(-1, func_name, "pause_ms == " + a_pause_ms
            + " > pause_up == " + pause_up);
        set_log(tim_cur, s, true);
    }
}

//----

int set_log(datetime log_datetime, string note, bool write_to_file)
{
    string func_name = "set_log";
    int i = log_num;
    log_num++;
    int j = 0;
    int e1 = 1;
    while (e1 != 0 && j < try_cnt)
    {
        ArrayResize(log_a1, log_num);
        int lst_err = GetLastError();
        if (lst_err != 0)
            error(lst_err, func_name, "ArrayResize()");
        e1 = lst_err;
        j++;
    }
    if (j != try_cnt)
    {
        log_a1[i] = TimeToStr(log_datetime, TIME_DATE | TIME_SECONDS)
            + " (" + log_datetime + "). " + note;
        if (write_to_file != false)
        {
            e1 = log_file_write();
            return(e1);
        }
        else
            return(0);
    }
    else
        return(-1);
}

//----

int file_exist(string a_filename, bool & result)
{
    string func_name = "file_exist()";
    int handle = FileOpen(a_filename, FILE_CSV | FILE_READ,
        delimiter);
    int lst_err = GetLastError();
    if (handle != -1 && lst_err == 0)
    {
        FileClose(handle);
        int e1 = chk_error(func_name, "FileClose()", false);
        result = true;
        return(e1);
    }
    else
    {
        result = false;
        return(0);
    }
}

//----

int file_write(string note)
{
    string func_name = "file_write()";
    int handle = FileOpen(filename, FILE_CSV | FILE_READ
        | FILE_WRITE, delimiter);
    int e1 = chk_error(func_name, "FileOpen()", true);
    if (e1 != 0)
        return(e1);
    FileSeek(handle, 0, SEEK_END);
    e1 = chk_error(func_name, "FileSeek()", true);
    if (e1 != 0)
    {
        FileClose(handle);
        chk_error(func_name, "FileClose()", true);
        return(e1);
    }
    FileWrite(handle, note);
    e1 = chk_error(func_name, "FileWrite()", true);
    if (e1 != 0)
    {
        FileClose(handle);
        chk_error(func_name, "FileClose()", true);
        return(e1);
    }
    FileClose(handle);
    e1 = chk_error(func_name, "FileClose()", true);
//    if (e1 == 0)
//        complete(func_name, "no errors");
    return(e1);
}

//----

int log_file_write()
{
    string func_name = "log_file_write()";
    int handle = FileOpen(log_filename, FILE_CSV | FILE_READ
        | FILE_WRITE, delimiter);
    int e1 = chk_error(func_name, "FileOpen()", false);
    if (e1 != 0)
        return(e1);
    FileSeek(handle, 0, SEEK_END);
    e1 = chk_error(func_name, "FileSeek()", false);
    if (e1 != 0)
    {
        FileClose(handle);
        chk_error(func_name, "FileClose()", false);
        return(e1);
    }
    while (log_num_pre < log_num)
    {
        FileWrite(handle, log_a1[log_num_pre]);
        e1 = chk_error(func_name, "FileWrite()", false);
        if (e1 != 0)
        {
            FileClose(handle);
            chk_error(func_name, "FileClose()", false);
            return(e1);
        }
        log_num_pre++;
    }
    FileClose(handle);
    e1 = chk_error(func_name, "FileClose()", false);
    if (e1 == 0)
        complete(func_name, "no errors");
    return(e1);
}

//+------------------------------------------------------------------+